#pragma once

#include <tchar.h>
#include <Windows.h>

/**
 * SMFɊ܂܂Cxg1̏
 */
class StandardMidiFormatEvent
{
public:

	/**
	 * Cxg̎
	 */
	enum Type : BYTE
	{
		MIDI,
		SYS_EX,
		META,
	};

	/**
	 * MIDICxg̎
	 */
	enum MidiType : BYTE
	{
		NOTE_OFF                = 0x80,
		NOTE_ON                 = 0x90,
		POLYPHONIC_KEY_PRESSURE = 0xa0,
		CONTROL_CHANGE          = 0xb0,
		PROGRAM_CHANGE          = 0xc0,
		CHANNEL_PRESSURE        = 0xd0,
		PITCH_BEND              = 0xe0,
	};

	/**
	 * SysExCxg̎
	 */
	enum SysExType : BYTE
	{
		F0 = 0xf0,
		F7 = 0xf7,
	};

	/**
	 * ^Cxg̎
	 */
	enum MetaType : BYTE
	{
		SEQUENCE_NUMBER          = 0x00,
		TEXT                     = 0x01,
		COPYRIGHT                = 0x02,
		SEQUENCE                 = 0x03,
		INSTRUMENT_NAME          = 0x04,
		LYRIC                    = 0x05,
		MARKER                   = 0x06,
		CUE_POINT                = 0x07,
		PROGRAM_NAME             = 0x08,
		DEVICE_NAME              = 0x09,
		MIDI_CHANNEL_PREFIX      = 0x20,
		MIDI_PORT                = 0x21,
		END_OF_TRACK             = 0x2f,
		TEMPO                    = 0x51,
		SMPTE_OFFSET             = 0x54,
		TIME_SIGNATURE           = 0x58,
		KEY_SIGNATURE            = 0x59,
		SEQUENCER_SPECIFIC_EVENT = 0x7f,
	};

	/**
	 * ̃Cxg܂ł̎(tick)
	 */
	DWORD deltaTime;

	/**
	 * Cxg̎
	 */
	Type type;

	/**
	 * Cxgނɂĕێf[^(gp郁oϐ)ς
	 */
	union
	{
		/**
		 * MIDICxg
		 */
		struct
		{
			/**
			 * MIDICxg̎
			 */
			MidiType midiType;

			/**
			 * Ώۂ̃`l
			 */
			BYTE channel;
			
			union
			{
				/**
				 * sb`xh
				 */
				WORD pitchBend;

				struct
				{
					/**
					 * m[gԍ
					 *
					 * 鉹K
					 */
					BYTE noteNumber;

					/**
					 * xVeB
					 *
					 * Ղb肷鎞̑x
					 * {Iɂ͉ʓIȈӖ
					 */
					BYTE velocity;
				};

				struct
				{
					/**
					 * Rg[ԍ
					 *
					 * Rg[`FWCxg̏ꍇɑΏۂ̃Rg[ԍZbg
					 * `l[hbZ[W̏ꍇbZ[Wԍ(0x78-0x7f)
					 */
					BYTE controlNumber;

					/**
					 * Rg[`FW̒l
					 */
					BYTE controlValue;
				};

				/**
				* vO`FW̒l(F)
				*/
				BYTE program;
			};
		};

		/**
		 * SysExCxg
		 */
		struct
		{
			/**
			 * SysExCxg̎
			 */
			SysExType sysExType;

			/**
			 * f[^
			 *
			 * dataɊi[Ăf[^TCY
			 */
			WORD dataLength;

			/**
			 * f[^
			 *
			 * f[^TCYdataLengthQ
			 */
			const BYTE* data;
		};

		/**
		 * ^Cxg
		 */
		struct
		{
			/**
			 * ^Cxg̎
			 */
			MetaType metaType;

			/**
			 * f[^
			 *
			 * dataɊi[Ăf[^TCY
			 */
			WORD dataLength;

			/**
			 * f[^
			 *
			 * f[^TCYdataLengthQ
			 */
			const BYTE* data;
		};
	};
};

/**
 *
 *
 * Memo:
 *  `l = y
 *  gbNƃ`l̊֘A͓ɂȂ
 *    ʓIɂ1̃`l(y)̃f[^1̃gbNɓ悤ɍ邪
 *    SDFtH[}bgIɂ͕̃gbNɕĂ悢A1̃gbNɕ`l̃f[^Ă悢
 *    (tH[}bg0PgbNɑS`lĂ`)
 */
class StandardMidiFormat
{
public:

	/**
	 * loadFileG[: t@CI[voȂ
	 */
	constexpr static LRESULT LOAD_ERROR_FILE_OPEN = 1;

	/**
	 * loadFileG[: 4GBȏ̃t@C͔Ή
	 */
	constexpr static LRESULT LOAD_ERROR_FILE_TOO_LARGE = 2;

	/**
	 * loadFileG[: t@CǂݍݒɕsȃG[
	 */
	constexpr static LRESULT LOAD_ERROR_FILE_READ = 3;

	/**
	 * loadFileG[: SMFƂĕs
	 */
	constexpr static LRESULT LOAD_ERROR_ILLEGAL_SMF = 4;

	/**
	 * loadFileG[: T|[gĂȂSMF`
	 */
	constexpr static LRESULT LOAD_ERROR_NOT_SUPPORT_SMF = 5;
	
	/**
	 * RXgN^
	 */
	StandardMidiFormat();
	
	/**
	 * fXgN^
	 */
	~StandardMidiFormat();

	/**
	 * t@Cǂݍ
	 *
	 * @param filepath t@CpX
	 *
	 * @return 
	 */
	LRESULT loadFile(const TCHAR* filepath);

	/**
	 * l̕\(Tick)擾
	 *
	 * @return l̕\(Tick)
	 */
	WORD getQuarterNoteTick();

	/**
	 * ̃Cxgǂݏo
	 *
	 * ĂяoƂɓǏoJ[\iݎ̃Cxgǂݏo
	 *
	 * @param event ǂݏof[^̏ݐ
	 *
	 * @return ǏosꂽꍇtrueԂ
	 *         Ō̃Cxg܂œǏoς݂œǂݏoꍇfalseԂ
	 */
	bool next(StandardMidiFormatEvent* event);

	/**
	 * Cxg̓ǏoJ[\擪ɖ߂
	 */
	void rewind();

private:

	/**
	 * `N^Cv: wb_ (MThd)
	 */
	constexpr static DWORD CHUNK_TYPE_HEADER = 0x4d546864;

	/**
	 * `N^Cv: gbN (MTrk)
	 */
	constexpr static DWORD CHUNK_TYPE_TRACK = 0x4d54726b;
	
	/**
	 * wb_`Ñf[^(6byteŒ)
	 */
	constexpr static DWORD HEADER_CHUNK_LENGTH = 6;

	/**
	 * tH[}bg^Cv
	 *
	 * tH[}bg2Ƃ̂Ki㑶݂̂
	 * gp邱ƂHł\C}C`悭킩̂Ō_ł͔ΉƂ
	 */
	enum Format
	{
		TYPE_0 = 0, // tH[}bg0: 1gbNɑSẴCxg܂Ƃ߂`
		TYPE_1 = 1, // tH[}bg1: t镡̃gbNō\
	};

	/**
	 * gbNǏopf[^
	 */
	class TrackReader
	{
	public:
		/**
		 * gbNJnʒu
		 *
		 * gbNŏ̃bZ[W̐擪oCg̃|C^
		 * MTrkgbNf[^̈ʒuł͂Ȃ
		 */
		BYTE* start;

		/**
		 * gbNIʒu
		 *
		 * gbNGh̍ŏIoCg̎̃|C^
		 * start + gbNf[^
		 */
		BYTE* end;

		/**
		 * ǏoJ[\
		 */
		BYTE* cursor;

		/**
		 * ǏoJ[\wbZ[W̃f^^C
		 *
		 * ߂̃bZ[W邽߂ɕQƂ̂ŃfR[h̏ێĂ
		 */
		DWORD deltaTime;

		/**
		 * jOXe[^X̂߂1OMIDICxgL^Ă
		 */
		BYTE lastMidiEvent;
	};

	/**
	 * oCif[^TCY
	 */
	DWORD dataLength_;

	/**
	 * oCif[^
	 */
	BYTE* data_;

	/**
	 * tH[}bg
	 */
	Format format_;

	/**
	 * gbN
	 *
	 * tH[}bg0̏ꍇ1Œ ȊȌꍇ̓gbN
	 */
	WORD track_;

	/**
	 * gbNǏof[^(1gbNɂ1)
	 */
	TrackReader* trackReaders_;

	/**
	 * l̕\
	 *
	 * ^Cx[Xe|x[X̏ꍇɎl̕\(P: Tick)
	 * eCxg̃f^^C͂̐ɑ΂銄
	 * (: ^Cx[X(l̕\)480Tick̏ꍇAf^^CSȂ1960TickAȂ240TickƂȂ)
	 * Ԃɂ邽߂ɂ̓e|KvƂȂAȉ̌vZŋ߂
	 * f^^C(}CNb) = (f^^C(Tick) / ^Cx[X(Tick)) * e|ݒ(}CNb/Tick)
	 */
	WORD quarterNoteTick_;

	/**
	 * OMNI[hON/OFF
	 *
	 * next֐̌ĂяoʂɂIɃXe[^Xϓ
	 */
	bool omni_;

	/**
	 * MONO[hON/OFF
	 *
	 * next֐̌ĂяoʂɂIɃXe[^Xϓ
	 */
	bool mono_;

	constexpr WORD readWord(BYTE*& p)
	{
		WORD result = *p++;
		result <<= 8;
		result |= *p++;
		return result;
	}

	constexpr DWORD readDword(BYTE*& p)
	{
		DWORD result = *p++;
		result <<= 8;
		result |= *p++;
		result <<= 8;
		result |= *p++;
		result <<= 8;
		result |= *p++;
		return result;
	}
};
